<?php
require_once("../../config/config.inc.php");
require_once("KDbTools.inc.php");
require_once("autoloader.inc.php");
autoloader::init();
require_once(KDbConfig::getCwfPath()."admin/EventFormUI.inc.php");
CWFTools::startSession("k_db_admin");
putenv("LC_ALL={$_SESSION['lang']}");
setlocale(LC_ALL, $_SESSION['lang']);
bindtextdomain("default", KDbConfig::getCwfPath()."locale");
textdomain("default");
bind_textdomain_codeset("default", "UTF-8");
?>
//<script type="text/javascript">

var feeGroupHeader = '<?=str_replace(array("\r", "\n", "\f"), "", EventFormUI::getHTMLOptionGroupHeader());?>';
var feeGroupFooter = '<?=str_replace(array("\r", "\n", "\f"), "", EventFormUI::getHTMLOptionGroupFooter())?>';
var feeGroup = '<?=str_replace(array("\r", "\n", "\f"), "", EventFormUI::getHTMLOptionGroup())?>';
var eventFees = '<?=str_replace(array("\r", "\n", "\f"), "", EventFormUI::getHTMLEventOption(OPTION_GROUP_FEES))?>';
var tickets = '<?=str_replace(array("\r", "\n", "\f"), "", EventFormUI::getHTMLEventOption(OPTION_GROUP_TICKETS))?>';
var addInfo = '<?=str_replace(array("\r", "\n", "\f"), "", EventFormUI::getHTMLEventOption(OPTION_GROUP_ADDINFO))?>';
var deadline = '<?=str_replace(array("\r", "\n", "\f"), "", EventFormUI::getHTMLFee())?>';

function kdbAddOptionGroup(dialog) {
  var currentID;
  if($('div.kdb_option_group:last *[name^="required"]').length>0)
    currentID = parseInt($('div.kdb_option_group:last *[name^="required"]').attr("name").replace(/^.*\[([0-9]+)\]$/, "$1"));
  else
    currentID = -1;

  var type = $('#dialog_option_group_type', dialog).val();
  switch(type) {
    case "<?=OPTION_GROUP_FEES?>":
      if($('#dialog_exclusive', dialog).prop("checked"))
          $('#kdb_event_fees').append((feeGroupHeader+feeGroup+eventFees+feeGroupFooter.replace(/\$type\$/, type)).replace(/((for|name|id)="([^"]*?))\[\]/g, "$1["+(currentID+1)+"]").replace(/\[\]/g, "[0]"));
      else
          $('#kdb_event_fees').append((feeGroupHeader+feeGroup+eventFees.replace(/radio/g, "checkbox")+feeGroupFooter.replace(/\$type\$/, "1")).replace(/((for|name|id)="([^"]*?))\[\]/g, "$1["+(currentID+1)+"]").replace(/\[\]/g, "[0]"));
      $('div.kdb_option_group:last *[name^="allow_changes"]').prop("disabled", true);
      break;
    case "<?=OPTION_GROUP_TICKETS?>":
      $('#kdb_event_fees').append((feeGroupHeader+feeGroup+tickets+feeGroupFooter.replace(/\$type\$/, type)).replace(/((for|name|id)="([^"]*?))\[\]/g, "$1["+(currentID+1)+"]").replace(/\[\]/g, "[0]"));
      $('div.kdb_option_group:last *[name^="allow_changes"]').prop("disabled", true);
      $('div.kdb_option_group:last *[name^="enable_waitlist"]').prop("disabled", true);
      break;
    case "<?=OPTION_GROUP_ADDINFO ?>":
      $('#kdb_event_fees').append((feeGroupHeader+feeGroup+addInfo+feeGroupFooter.replace(/\$type\$/, type)).replace(/((for|name|id)="([^"]*?))\[\]/g, "$1["+(currentID+1)+"]").replace(/\[\]/g, "[0]"));
      $('div.kdb_option_group:last *[name^="exclusive"]').prop("disabled", true);
      $('div.kdb_option_group:last *[name^="enable_waitlist"]').prop("disabled", true);
      break;
  }
  if($('#dialog_option_group_type', dialog).val()>0) {
    $('div.kdb_option_group:last *[name^="group_name"]').val($('#dialog_option_group_name', dialog).val());
    $('div.kdb_option_group:last *[name^="group_type"]').val($('#dialog_option_group_type', dialog).val());
    $('div.kdb_option_group:last *[name^="group_type_display"]').val($('#dialog_option_group_type', dialog).val());
    if ($('#dialog_exclusive:checked', dialog).length>0) {
      $('div.kdb_option_group:last *[name^="exclusive"]').prop("checked",true);
    }
    else {
      $('div.kdb_option_group:last *[name^="exclusive"]').prop("checked",false);
    }
    if ($('#dialog_allow_changes:checked', dialog).length>0) {
      $('div.kdb_option_group:last *[name^="allow_changes"]').prop("checked",true);
    }
    else {
      $('div.kdb_option_group:last *[name^="allow_changes"]').prop("checked",false);
    }
    if ($('#dialog_enable_waitlist:checked', dialog).length>0)
      $('div.kdb_option_group:last *[name^="enable_waitlist"]').prop("checked", true);
    else
      $('div.kdb_option_group:last *[name^="enable_waitlist"]').prop("checked", false);
  }
  setupTooltips();
  setupShowWarning();
  kdbHideDialog();
}

function kdbAddOption(element, type) {
  var currentID = $('*[name^="event_option_id"]:last', element.closest(".kdb_option_group_details")).attr("name").replace(/^.*\[([0-9]+)\]\[([0-9]+)\]$/, "$1 $2").split(" ");
  currentID[1] = parseInt(currentID[1]);
  
  switch (type) {
    case <?=OPTION_GROUP_FEES?>:
      var exclusive = ($('*[name^="exclusive"]', element.closest(".kdb_option_group_details")).prop("checked"));
      if (exclusive=="1")
          element.before(eventFees.replace(/((name|id)="([^"]*?))\[\]\[\]/g, "$1["+(currentID[0])+"]["+(currentID[1]+1)+"]").replace(/\[\]/g, "[0]"));
      else
          element.before(eventFees.replace(/((name|id)="([^"]*?))\[\]\[\]/g, "$1["+(currentID[0])+"]["+(currentID[1]+1)+"]").replace(/\[\]/g, "[0]").replace(/radio/g, "checkbox"));
      break;
    case <?=OPTION_GROUP_TICKETS ?>:
      element.before(tickets.replace(/((name|id)="([^"]*?))\[\]\[\]/g, "$1["+(currentID[0])+"]["+(currentID[1]+1)+"]").replace(/\[\]/g, "[0]"));
      break;
    case <?=OPTION_GROUP_ADDINFO?>:
      element.before(addInfo.replace(/((name|id)="([^"]*?))\[\]\[\]/g, "$1["+(currentID[0])+"]["+(currentID[1]+1)+"]").replace(/\[\]/g, "[0]"));
      break;
  }
}

function kdbDeadlineAdd(element) {
  var currentID = $('*[name^="event_fee_id"]', element.closest("div")).attr("name").replace(/^.*\[([0-9]+)\]\[([0-9]+)\]\[([0-9]+)\]$/, "$1 $2 $3").split(" ");
  var exclusive = ($('*[name^="exclusive"]', element.closest(".kdb_option_group_details")).prop("checked"));
  currentID[2] = parseInt(currentID[2]);
  
  if (exclusive=="1")
      element.closest(".kdb_fee_details").append(deadline.replace(/((name|id)="([^"]*?))(\[\]){3}/g, "$1["+(currentID[0])+"]["+(currentID[1])+"]["+(currentID[2]+1)+"]"));
  else
      element.closest(".kdb_fee_details").append(deadline.replace(/radio/g, "checkbox").replace(/((name|id)="([^"]*?))(\[\]){3}/g, "$1["+(currentID[0])+"]["+(currentID[1])+"]["+(currentID[2]+1)+"]"));
  element.remove();
}

function kdbDeadlineDel(element) {
  var parentFeeDetails = element.closest(".kdb_fee_details");

  var groupType = element.closest('div.kdb_option_group').find('*[name^=group_type]').val();
  switch (groupType) {
    case "<?=OPTION_GROUP_FEES ?>":
      if(element.closest('.kdb_deadline').find('*[name^=event_fee_id]').val() && 
         !confirm('<?=_('Do you really want to delete this fee? Warning: All bookings of this fee will be permanently deleted as well!');?>')) return;
      break;
    case "<?=OPTION_GROUP_TICKETS?>":
    case "<?=OPTION_GROUP_ADDINFO ?>":
      if(element.closest('.kdb_eventoption').find('*[name^=event_option_id]').val() && 
         !confirm('<?=_('Do you really want to delete this item? Warning: All data submitted by users for this item will be permanently deleted as well!');?>')) return;
      break;
  }
  
  if($('> div', parentFeeDetails).length==1) {
    if($('.kdb_eventoption', parentFeeDetails.closest(".kdb_option_group_details")).length==1)
      parentFeeDetails.closest("div.kdb_option_group").remove();
    else
      parentFeeDetails.closest(".kdb_eventoption").remove();
  }
  else {
    if(element.closest("div").find('button').length==2) {
      element.closest("div").remove();
      $('div:last', parentFeeDetails).append('<button onClick="kdbDeadlineAdd($(this));" type="button"><img src="../../k_db/img/icons/add.png" alt="New" height="12" width="12"></button>');
    }
    else
      element.closest("div").remove();
  }
}

function kdbShowAddInfo(element) {
  $groupConfig = element.closest(".kdb_option_group_details").find('.kdb_option_group_config');
  if($groupConfig.hasClass('visible')) {
    element.removeClass('add_info_open');
    $groupConfig.removeClass('visible');
    $groupConfig.hide();
  }
  else { 
    element.addClass('add_info_open');
    $groupConfig.addClass('visible');
    $groupConfig.show();
  }
}

function kdbHideDialog() {
  $('#dialog_option_group input').each(function(index){
    if($(this).attr('type')=='checkbox')
      $(this).prop('checked', false).prop('disabled', true);
    else if($(this).attr('type')!='button') 
      $(this).val('');}
  );
  $('#dialog_option_group select').each(function() { $(this).val($("option:first", this).val()); });
  $('#dialog_option_group').hide();
  $('#dialog_option_group .dialog_preview div').hide();
  $('#dialog_option_group .dialog_preview #dialog_'+$('option:selected', this).text().toLowerCase().replace(/ /, '_')+'_preview').show();
  $('#dialog_option_group .dialog_preview #dialog_option_group_name_preview').text(""); 
}

function kdbShowPanel(panel) {
  $('#side_panel_content *', panel).remove();
  $('div.kdb_option_group').each(function(index) {
      optionGroup = this;
      groupIdx = $('*[name^="group_name"]', this).attr("name").replace(/^group_name/, '');
      groupType = $('*[name="group_type'+groupIdx+'"]', this).val();
      groupExclusive = ($('*[name="exclusive'+groupIdx+'"]', this).prop("checked"));
      $('#side_panel_content', panel).append('<h3>'+$('*[name^="group_name"]', this).val()+'</h3>');
      $('#side_panel_content', panel).append('<p>'+$('*[name^="description'+groupIdx+'"]', this).val()+'</p>');
      if(groupType=="<?=OPTION_GROUP_TICKETS?>" && groupExclusive) {
        var optionsCategories = "";
        $('*[name^="event_option'+groupIdx+'"]', this).each(function(index) {
          optionIdx = $(this).attr("name").replace(/^event_option/, '');
          fee = $('*[name^="event_fee'+optionIdx+'"]:first', optionGroup).val();
          optionsCategories += '<option value="'+optionIdx+'">'+$(this).val()+(fee ? ' (<?=KDbConfig::getCurrency()?> '+fee+'.--)' : '')+'</option>';
        });
        var optionsBookings = "";
        for(var i=1; i<=$('*[name^="booking_limit"]:first', optionGroup).val(); i++) optionsBookings += '<option>'+i+' <?=_("tickets")?></option>';
        $('#side_panel_content', panel).append('<p><span class="form_element"><select class="ticket_category">'+optionsCategories+'</select></span>'+
                                               '<span class="form_element"><select class="no_tickets">'+optionsBookings+'</select></span></p>');
      }
      else {
        $('*[name^="event_option'+groupIdx+'"]', this).each(function(index) {
          optionIdx = $(this).attr("name").replace(/^event_option/, '');
          switch(groupType) {
            case "<?=OPTION_GROUP_FEES ?>":
              fee = $('*[name^="event_fee'+optionIdx+'"]:first', optionGroup).val();
              $('#side_panel_content', panel).append('<p><label>'+$(this).val()+'</label>'+
                                                     '<input type="'+((groupExclusive=="1")?"radio":"checkbox")+'">'+
                                                     (fee ? '<span class="form_element"><?=KDbConfig::getCurrency()?> '+fee+'.--</span></p>' : ''));
              break;
            case "<?=OPTION_GROUP_TICKETS?>":
              fee = $('*[name^="event_fee'+optionIdx+'"]:first', optionGroup).val();
              var options = "";
              for(var i=1; i<=$('*[name^="booking_limit'+optionIdx+'"]', optionGroup).val(); i++) options += '<option>'+i+' <?=_("tickets")?></option>';
              $('#side_panel_content', panel).append('<p><label>'+$(this).val()+'</label>'+
                                                     '<span class="form_element">'+(fee ? ' <?=KDbConfig::getCurrency()?> '+fee+'.-- ' : '')+
                                                     '<select class="no_tickets">'+options+'</select></span></p>');
              break;
            case "<?=OPTION_GROUP_ADDINFO ?>":
              optionType = $('*[name^="option_type'+optionIdx+'"] option:selected', optionGroup).val();
              switch(optionType) {
                case "<?=EVENT_OPTION_TEXT?>": $('#side_panel_content', panel).append('<p><label>'+$(this).val()+':</label><input type="text"></p>'); break;
                case "<?=EVENT_OPTION_TEXT_MULTILINE ?>": $('#side_panel_content', panel).append('<p><label>'+$(this).val()+':</label><textarea></textarea></p>'); break;
                case "<?=EVENT_OPTION_DATE ?>": $('#side_panel_content', panel).append('<p><label>'+$(this).val()+':</label><input type="text"></p>'); break;
                case "<?=EVENT_OPTION_NUMBER_INT?>": $('#side_panel_content', panel).append('<p><label>'+$(this).val()+':</label><input type="text"></p>'); break;
                case "<?=EVENT_OPTION_NUMBER_DEC ?>": $('#side_panel_content', panel).append('<p><label>'+$(this).val()+':</label><input type="text"></p>'); break;
                case "<?=EVENT_OPTION_SELECT ?>":
                  optionList = '<option></option><option>'+$('*[name^="list'+optionIdx+'"]', optionGroup).val().replace(/\s*,\s*/g, '</option><option>')+'</option>';
                  $('#side_panel_content', panel).append('<p><label>'+$(this).val()+':</label><select>'+optionList+'</select></p>'); 
                  break;
              }
              break;
          }
        });
      }
    });
  panel.animate({right:'-5px'}, 500);
}

function kdbChangeExclusive(item) {
  if(item.prop('checked')) {
      item.closest('.kdb_option_group_details').find('input[name=dummy]').after('<input type="radio" name="dummy" value="1" disabled>').remove();
  }
  else
    item.closest('.kdb_option_group_details').find('input[name=dummy]').after('<input type="checkbox" name="dummy" value="1" disabled>').remove();
}

function setupShowWarning() {
  if($('div.kdb_option_group input[name^=required]').length>0) {
    if($('div.kdb_option_group input[name^=required]:checked').length>0)
      $('#kdb_required_warning').hide(300);
    else
      $('#kdb_required_warning').show(300);
  }
  $('div.kdb_option_group input[name^=required]').change(function() {
    if($('div.kdb_option_group input[name^=required]:checked').length>0)
      $('#kdb_required_warning').hide(300);
    else
      $('#kdb_required_warning').show(300);
  });
}

function kdbResetFeeIds() {
  $('#kdb_event_fees input[name*="_id["]').val("");
  setupTooltips();
}

function kdbEventFormCopy(formElement) {
  var id = $(formElement).closest('form').find('#dialog_event_list').val(); 
  ajaxSendRequest(ajaxLoadData, $('#kdb_form'), {"action": "updateForm", "id": id, "className": "EventFormUI", "formName": "kdb_form"}, kdbResetFeeIds);
}

function kdbShowCopyDialog() {
  var feeIdsExist = $('*[name^=event_fee_id][value!=""]').length;
  if(feeIdsExist>0 && 
     !confirm('<?=_('Do you really want to copy the form from another event? Warning: All bookings for this event will be permanently deleted!');?>')) 
    return;

  $('#dialog_copy_form').show(); 
}

$(document).ready(function() {
  $("#side_panel").hoverIntent(function(){
      kdbShowPanel($(this));
    },
    function(){
      $(this).animate({right:'-470px'}, 500);
    });

  var options = new Array();
  options[<?=OPTION_GROUP_FEES ?>] = 'event_fee';
  options[<?=OPTION_GROUP_TICKETS ?>] = 'tickets';
  options[<?=OPTION_GROUP_ADDINFO ?>] = 'additional_information';
  
  $('#dialog_option_group .dialog #dialog_option_group_type').change(function() {
    if($(this).val()==<?=OPTION_GROUP_FEES ?>) {
      $('#dialog_option_group .dialog #dialog_exclusive').prop('disabled', false);
      $('#dialog_option_group .dialog #dialog_allow_changes').prop("disabled", true).prop("checked", false);
      $('#dialog_option_group .dialog #dialog_enable_waitlist').prop("disabled", false);
      $('#dialog_option_group .dialog #dialog_exclusive').trigger("change");
    }
    else if($(this).val()==<?=OPTION_GROUP_TICKETS ?>) {
      $('#dialog_option_group .dialog #dialog_exclusive').prop('disabled', false);
      $('#dialog_option_group .dialog #dialog_allow_changes').prop("disabled", true).prop("checked", false);
      $('#dialog_option_group .dialog #dialog_enable_waitlist').prop("disabled", true).prop("checked", false);
      $('#dialog_option_group .dialog #dialog_exclusive').trigger("change");
    }
    else if($(this).val()==<?=OPTION_GROUP_ADDINFO ?>) {
      $('#dialog_option_group .dialog #dialog_exclusive').prop("disabled", true).prop("checked", false);
      $('#dialog_option_group .dialog #dialog_allow_changes').prop('disabled', false);
      $('#dialog_option_group .dialog #dialog_enable_waitlist').prop("disabled", true).prop("checked", false);
    }
    else {
      $('#dialog_option_group .dialog #dialog_exclusive').prop("disabled", true).prop("checked", false);
      $('#dialog_option_group .dialog #dialog_allow_changes').prop("disabled", true).prop("checked", false);
      $('#dialog_option_group .dialog #dialog_enable_waitlist').prop("disabled", true).prop("checked", false);
    }
    $('#dialog_option_group .dialog_preview > div').hide();
    $('#dialog_option_group .dialog_preview #dialog_'+options[$('option:selected', this).val()]+'_preview').show();
  });
  
  $('#dialog_option_group .dialog #dialog_option_group_name').keyup(function() { 
    $('#'+$(this).attr('id')+'_preview').text($(this).val()); 
  });

  $('#dialog_option_group .dialog #dialog_exclusive').change(function() {
    switch ($('#dialog_option_group .dialog #dialog_option_group_type').val()) {
      case "<?=OPTION_GROUP_FEES ?>":
        if($(this).prop('checked'))
          $('#dialog_option_group .dialog_preview input:checkbox').after('<input type="radio" name="'+this.name+'" value="1" disabled>').remove();
        else 
          $('#dialog_option_group .dialog_preview input:radio').after('<input type="checkbox" name="'+this.name+'" value="1" disabled>').remove();
        break;
      case "<?=OPTION_GROUP_TICKETS?>":
        $('#dialog_option_group .dialog_preview #dialog_tickets_preview div').hide();
        if($(this).prop('checked'))
          $('#dialog_option_group .dialog_preview #dialog_tickets_preview #dialog_tickets_preview_excl').show();
        else
          $('#dialog_option_group .dialog_preview #dialog_tickets_preview #dialog_tickets_preview_nexcl').show();
        break;
    }
  });

  $('#side_panel_content').on('change', 'select.ticket_category', function() {
    var optionIdx = $(this).val();
    var optionsBookings = "";
    for(var i=1; i<=$('*[name^="booking_limit'+optionIdx+'"]').val(); i++) optionsBookings += '<option>'+i+'</option>';

    $('select.no_tickets', $(this).closest('p')).replaceWith('<select class="no_tickets">'+optionsBookings+'</select>');
  });
  $('#kdb_event_fees').on('change', 'select[name^=option_type]', function() {
    if($(this).val()==<?=EVENT_OPTION_SELECT?>)
      $('input[name^=list]', $(this).closest('div')).show();
    else
      $('input[name^=list]', $(this).closest('div')).val('').hide();
  });
  setupShowWarning();
});


//</script>